#! /usr/bin/env python
# coding=utf-8

import rb
import gobject
import gtk
import rhythmdb
import GoogleMusicProxy
import traceback
import webbrowser
import threading
import time


class GoogleMusicPlugin(rb.Plugin):
  def __init__(self):

    rb.Plugin.__init__(self)
  def activate(self, shell):
    self.db = shell.props.db

    self.entry_type = self.db.entry_register_type("googlemusic")
    self.entry_type.get_playback_uri=self.get_playback_uri
    
    width, height = gtk.icon_size_lookup(gtk.ICON_SIZE_LARGE_TOOLBAR)
    icon = gtk.gdk.pixbuf_new_from_file_at_size(self.find_file("google.png"), width, height)

    group = rb.rb_source_group_get_by_name ("Online")
    if not group:
	group = rb.rb_source_group_register ("Online",
					     _("在线音乐"),
					     rb.SOURCE_GROUP_CATEGORY_FIXED)

    self.source = gobject.new (googlemusic,
					   shell=shell,
					   entry_type=self.entry_type,
					   plugin=self,
					   icon=icon,
					   source_group=group)
    shell.append_source(self.source, None)
    shell.register_entry_type_for_source(self.source, self.entry_type)


    # First lets see if we can add to the context menu
    ui = shell.get_ui_manager()

    # Group and it's actions
    self.action_group = gtk.ActionGroup ('google')


    # Create Actions for the plugin
    action = gtk.Action ('browsemusic', _('乐库'),
                         _('乐库'),
                         'gtk-properties')#gtk-preferences
    activate_id = action.connect ('activate', lambda a: self.browse_music())
    self.action_group.add_action (action)

    ui.insert_action_group(self.action_group, 0)

  def deactivate(self, shell):
    ui = shell.get_player().get_property('ui-manager')
    ui.remove_action_group(self.action_group)
    self.action_group = None
    
    GoogleMusicProxy.saveList()
    for row in self.source.props.query_model:
      entry = row[0]
      self.db.entry_delete(entry)
    self.db.commit()
    
    self.db = None
    self.entry_type = None
    
    self.source.delete_thyself()
    self.source = None

      

  def browse_music(self):
    webbrowser.open_new("http://localhost:52099/music/homepage")


		
  def get_playback_uri(self,entry):
    if not entry:return None
    id=self.db.entry_get(entry, rhythmdb.PROP_LOCATION)
    url=GoogleMusicProxy.getSongUrl(id)
    if url:
        return url
    return None




class googlemusic(rb.BrowserSource):
  def __init__(self):
    rb.BrowserSource.__init__(self,name=_("GoogleMusic"))
    GoogleMusicProxy.bs = self
    self.__activated=False
    self.__progressing=False
    
  def do_impl_delete_thyself(self):
    
    self.entry_type = None
    self.db = None
    self.shell = None
    
    rb.BrowserSource.do_impl_delete_thyself (self)
    
  def do_impl_activate(self):
    if not self.__activated:
          self.__activated=True
          self.shell=self.get_property('shell')
          self.db = self.shell.get_property('db')
          self.entry_type = self.get_property('entry-type')
          ws = webserver(self)
          ws.start()
          GoogleMusicProxy.loadList()
    rb.BrowserSource.do_impl_activate (self)
    
  def do_impl_get_ui_actions(self):
    return ["browsemusic"]
    
  def do_impl_get_status(self):
    if self.__progressing:
      return (_("Loading songs"), None, -1.0)
    else:
      return (_("Done"), None, 1.0)
  
  def eos(self,player,stream_data,progress,shellplayer):
      print "eos"

    
  def notify_progress(self,progressing):
    self.__progressing=progressing
    self.notify_status_changed()



class webserver(threading.Thread):
    def __init__(self,bs):
        threading.Thread.__init__(self)
        self.BrowserSource = bs
    def run(self):
        httpd = GoogleMusicProxy.ThreadingHTTPServer(('localhost', 52099), GoogleMusicProxy.GoogleMusicProxyHandler )
        httpd.serve_forever()

gobject.type_register(googlemusic)
